$!  Make.com
$!  VMS script file to compile and link CBZone  
$!
$ on error then continue
$ CCOPT = "/Optimize/include=[]"
$!
$! Switches for DEC C/VAX C
$!
$ if f$getsyi("HW_MODEL").ge.1024
$ then
$  ccopt = ccopt + "/prefix=all"
$ else
$  if f$search("SYS$SYSTEM:DECC$COMPILER.EXE").nes."" 
$    then
$     ccopt = "/decc/prefix=all" + ccopt
$  endif
$ endif
$!
$! LNKOPT = "/MAP"
$ If P1 .EQS. "DEBUG" Then CCOPT  = CCOPT  + "/DEBUG/NOOPT"
$ If P1 .EQS. "DEBUG" Then LNKOPT = LNKOPT + "/DEBUG"
$!
$!	Build the option-file
$!
$ open/write optf cbzone.opt
$ write optf "c_main"
$ write optf "c_draw"
$ write optf "c_explode"
$ write optf "c_gpr"
$ write optf "c_graphics"
$ write optf "c_move"
$ write optf "c_parseopts"
$ write optf "c_scores"
$ write optf "unix_times"
$ write optf "Identification=""CBzone 91/01/13"""
$!
$!
$!  Find out which X-Version we're running.  This will fail for older
$!  VMS versions (i.e., v5.5-1).  Therefore, choose DECWindows XUI for
$!  default.
$!
$ On Error Then GoTo XUI
$ @sys$update:decw$get_image_version sys$share:decw$xlibshr.exe decw$version
$ if f$extract(4,3,decw$version).eqs."1.0"
$ then
$   write optf "Sys$share:DECW$DWTLIBSHR.EXE/Share"
$ endif
$ if f$extract(4,3,decw$version).eqs."1.1"
$ then
$   write optf "sys$share:decw$xtshr.exe/share"
$ endif
$ if f$extract(4,3,decw$version).eqs."1.2"
$ then
$   write optf "sys$share:decw$xtlibshrr5.exe/share"
$ endif
$ GoTo MAIN
$!
$XUI:
$!
$   write optf "Sys$share:DECW$DWTLIBSHR.EXE/Share"
$MAIN:
$!
$ write optf "sys$share:decw$xlibshr.exe/share"
$ close optf
$ On Error Then Continue
$!
$   CALL MAKE C_DRAW.OBJ "CC ''CCOPT' c_draw" -
            c_draw.c -
            c_includes.h 
$   CALL MAKE C_EXPLODE.OBJ "CC ''CCOPT' c_explode" -
            c_explode.c -
            c_includes.h 
$   CALL MAKE C_GPR.OBJ "CC ''CCOPT' c_gpr" -
            c_gpr.c -
            c_includes.h 
$   CALL MAKE C_GRAPHICS.OBJ "CC ''CCOPT' c_graphics" -
            c_graphics.c -
            c_includes.h 
$   CALL MAKE C_MAIN.OBJ "CC ''CCOPT' c_main" -
            c_main.c -
            c_includes.h 
$   CALL MAKE C_MOVE.OBJ "CC ''CCOPT' c_move" -
            c_move.c -
            c_includes.h 
$   CALL MAKE C_PARSEOPTS.OBJ "CC ''CCOPT'/def=(tankdir="""""""cbzone_dir:""""""") c_parseopts" -
            c_parseopts.c -
            c_includes.h 
$   CALL MAKE C_SCORES.OBJ "CC ''CCOPT'/def=(tankdir="""""""cbzone_dir:""""""") c_scores" -
            c_scores.c -
            c_includes.h 
$   CALL MAKE UNIX_TIMES.OBJ "CC ''CCOPT' unix_times.c" -
            unix_time.h
$!
$!
$!
$ CALL MAKE CBZONE.EXE "LINK ''LNKOPT' CBZONE.opt/OPT" *.OBJ
$!
$!
$ EXIT
$!
$!
$!
$!
$MAKE: SUBROUTINE   !SUBROUTINE TO CHECK DEPENDENCIES
$ V = 'F$Verify(0)
$! P1 = What we are trying to make
$! P2 = Command to make it
$! P3 - P8  What it depends on
$
$ If F$Search(P1) .Eqs. "" Then Goto Makeit
$ Time = F$CvTime(F$File(P1,"RDT"))
$arg=3
$Loop:
$       Argument = P'arg
$       If Argument .Eqs. "" Then Goto Exit
$       El=0
$Loop2:
$       File = F$Element(El," ",Argument)
$       If File .Eqs. " " Then Goto Endl
$       AFile = ""
$Loop3:
$       OFile = AFile
$       AFile = F$Search(File)
$       If AFile .Eqs. "" .Or. AFile .Eqs. OFile Then Goto NextEl
$       If F$CvTime(F$File(AFile,"RDT")) .Ges. Time Then Goto Makeit
$       Goto Loop3
$NextEL:
$       El = El + 1
$       Goto Loop2
$EndL:
$ arg=arg+1
$ If arg .Le. 8 Then Goto Loop
$ Goto Exit
$
$Makeit:
$ VV=F$VERIFY(0)
$ write sys$output P2
$ 'P2
$ VV='F$Verify(VV)
$Exit:
$ If V Then Set Verify
$ENDSUBROUTINE

